import { OnInit, NgZone, AfterViewInit, AfterContentChecked, AfterViewChecked, ElementRef, EventEmitter } from '@angular/core';
import 'fullcalendar';
import './lib/customEvent';
import { EventObjectInput, OptionsInput } from 'fullcalendar/src/types/input-types';
export declare class CalendarComponent implements OnInit, AfterViewInit, AfterContentChecked, AfterViewChecked {
    private element;
    private zone;
    private _eventsModel;
    private _reRender;
    eventsModel: EventObjectInput[];
    eventsModelChange: EventEmitter<any>;
    options: OptionsInput;
    eventDrop: EventEmitter<any>;
    eventResize: EventEmitter<any>;
    eventClick: EventEmitter<any>;
    clickButton: EventEmitter<any>;
    windowResize: EventEmitter<any>;
    viewRender: EventEmitter<any>;
    viewDestroy: EventEmitter<any>;
    eventRender: EventEmitter<any>;
    initialized: EventEmitter<any>;
    select: EventEmitter<any>;
    unselect: EventEmitter<any>;
    dayClick: EventEmitter<any>;
    navLinkDayClick: EventEmitter<any>;
    navLinkWeekClick: EventEmitter<any>;
    constructor(element: ElementRef, zone: NgZone);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterContentChecked(): void;
    ngAfterViewChecked(): void;
    updateEventsBeforeResize(): void;
    updaterOptions(): void;
    fullCalendar(...args: any[]): any;
    updateEvent(event: any): JQuery<HTMLElement>;
    clientEvents(idOrFilter: any): any;
    renderEvents(events: EventObjectInput[]): void;
}
